import { ref as o, onMounted as F, computed as B, watch as V, onBeforeUnmount as re, openBlock as u, createElementBlock as r, createElementVNode as z, normalizeStyle as d, unref as b, normalizeClass as Te, createTextVNode as G, toDisplayString as M, renderSlot as p, Fragment as q, renderList as D, normalizeProps as X, guardReactiveProps as j, createCommentVNode as E, createBlock as de, createSlots as Ae, withCtx as O, nextTick as xe } from "vue";
import { u as ke, c as we, o as J, e as K, w as Ie, q as Fe, r as Be } from "./index-Cm4Iry5c.js";
import { u as Oe } from "./useNestedProp-CurQIHTa.js";
import { u as Pe, U as Re } from "./usePrinter-B8RnF8_q.js";
import ze from "./vue-ui-skeleton-C1oUnz7R.js";
import { _ as Ee } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ne = ["id"], Se = ["height"], He = ["data-cell", "height"], Le = {
  __name: "vue-ui-carousel-table",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Object,
      default() {
        return {};
      }
    }
  },
  setup(f, { expose: ve }) {
    const l = f, { vue_ui_carousel_table: ce } = ke(), N = o(we()), Q = o(!1), y = o(!!l.dataset);
    F(() => {
      W();
    });
    function W() {
      J(l.dataset) ? K({
        componentName: "VueUiCarouselTable",
        type: "dataset"
      }) : ((!l.dataset.head || J(l.dataset.head)) && (K({
        componentName: "VueUiCarouselTable",
        type: "datasetAttribute",
        property: "head"
      }), y.value = !1), (!l.dataset.body || J(l.dataset.body)) && (K({
        componentName: "VueUiCarouselTable",
        type: "datasetAttribute",
        property: "body"
      }), y.value = !1));
    }
    const e = B({
      get: () => Y(),
      set: (t) => t
    });
    function Y() {
      return Oe({
        userConfig: l.config,
        defaultConfig: ce
      });
    }
    V(() => l.config, (t) => {
      e.value = Y(), W();
    }, { deep: !0 }), V(() => l.dataset, (t) => {
      S();
    }, { deep: !0 });
    const { isPrinting: Z, isImaging: _, generatePdf: pe, generateImage: ee } = Pe({
      elementId: `carousel-table_${N.value}`,
      fileName: e.value.caption.text || "vue-ui-carousel-table"
    }), v = o({
      showAnimation: e.value.animation.use
    }), s = o(null), te = o(null), C = o(null), $ = o(null), T = o(0), P = o(0), R = o(!1), A = o(null), h = o(null), x = o(0);
    function S() {
      A.value && (h.value = {
        elements: A.value.getElementsByTagName("tr"),
        heights: Array.from(A.value.getElementsByTagName("tr")).map((t) => t.getBoundingClientRect().height)
      });
    }
    F(S);
    const he = B(() => !h.value || !h.value.heights.length ? 0 : Math.max(...h.value.heights) + T.value + P.value), fe = B(() => l.dataset.body ? e.value.tbody.tr.visible <= l.dataset.body.length ? e.value.tbody.tr.visible : l.dataset.body.length : 0), ge = B(() => (e.value.tbody.tr.height + e.value.tbody.tr.td.padding.top + e.value.tbody.tr.td.padding.bottom + e.value.tbody.tr.border.size * 2) * fe.value + T.value + P.value), H = o(0), k = o(null), w = o(0), g = o(!1), ae = o(0);
    F(() => {
      C.value && (T.value = C.value.getBoundingClientRect().height), $.value && (P.value = $.value.getBoundingClientRect().height), v.value.showAnimation && h.value && oe();
    }), F(() => {
      if (s.value) {
        let a = function() {
          const i = t.getBoundingClientRect().bottom;
          n.forEach((c) => {
            c.getBoundingClientRect().top < i ? c.style.visibility = "hidden" : c.style.visibility = "visible";
          });
        };
        const t = s.value.querySelector("thead"), n = Array.from(A.value.querySelectorAll("tr"));
        s.value.addEventListener("scroll", a), a(), re(() => {
          s.value.removeEventListener("scroll", a);
        });
      }
    });
    function me(t) {
      Q.value = t, ae.value += 1;
    }
    function oe() {
      !k.value && !g.value && (k.value = requestAnimationFrame(ne));
    }
    function be() {
      if (!s.value) return !1;
      const { scrollTop: t, scrollHeight: n, clientHeight: a } = s.value;
      return t + a >= n;
    }
    function ne(t) {
      if (g.value) return;
      w.value || (w.value = t), t - w.value >= e.value.animation.speedMs && (H.value += h.value.heights[x.value], (be() || x.value >= h.value.heights.length) && (H.value = 0, x.value = -1), x.value += 1, s.value && s.value.scrollTo({
        top: H.value,
        behavior: "smooth"
      }), w.value = t), k.value = requestAnimationFrame(ne);
    }
    function m() {
      g.value = !0, cancelAnimationFrame(k.value), k.value = null;
    }
    re(m);
    function I() {
      !g.value || !v.value.showAnimation || (g.value = !1, w.value = 0, oe());
    }
    function ye() {
      e.value.animation.pauseOnHover && m();
    }
    const L = o(null);
    function Ce() {
      m(), clearTimeout(L.value);
    }
    function le() {
      clearTimeout(L.value), L.value = setTimeout(I, 1e3);
    }
    V(
      () => e.value.animation.use,
      (t) => {
        t ? (v.value.showAnimation = !0, I()) : (v.value.showAnimation = !1, m());
      }
    );
    const $e = B(() => e.value.responsiveBreakpoint);
    F(() => {
      const t = new ResizeObserver((n) => {
        n.forEach((a) => {
          R.value = a.contentRect.width < $e.value;
        }), T.value = C.value ? C.value.getBoundingClientRect().height : 0, P.value = $.value ? $.value.getBoundingClientRect().height : 0, x.value = 0, S();
      });
      s.value && t.observe(s.value);
    });
    function ie() {
      pe();
    }
    function se() {
      v.value.showAnimation = !v.value.showAnimation, v.value.showAnimation ? I() : m();
    }
    function ue() {
      xe(() => {
        const t = l.dataset.head.map((i, c) => [
          [l.dataset.body[c]]
        ]), n = [
          [e.value.caption.text],
          [l.dataset.head.map((i) => [i])]
        ].concat(t), a = Fe(n);
        Be({
          csvContent: a,
          title: e.value.caption.text || "vue-ui-carousel-table"
        });
      });
    }
    return ve({
      pauseAnimation: m,
      resumeAnimation: I,
      toggleAnimation: se,
      generateCsv: ue,
      generatePdf: ie,
      generateImage: ee
    }), (t, n) => (u(), r("div", {
      style: { position: "relative", overflow: "visible" },
      ref_key: "chartContainer",
      ref: te
    }, [
      z("div", {
        ref_key: "tableContainer",
        ref: s,
        id: `carousel-table_${N.value}`,
        style: d({
          height: b(Z) || b(_) ? "auto" : `${Math.max(ge.value, he.value)}px`,
          containerType: "inline-size",
          position: "relative",
          overflow: "auto",
          fontFamily: e.value.fontFamily
        }),
        class: Te({ "vue-ui-responsive": R.value, "is-playing": !g.value }),
        onMouseenter: n[0] || (n[0] = (a) => ye()),
        onMouseleave: n[1] || (n[1] = (a) => I()),
        onTouchstart: n[2] || (n[2] = (a) => Ce()),
        onTouchend: n[3] || (n[3] = (a) => le()),
        onTouchcancel: n[4] || (n[4] = (a) => le())
      }, [
        y.value ? (u(), r("table", {
          key: 0,
          class: "vue-data-ui-carousel-table",
          style: d({
            ...e.value.style,
            border: `${e.value.border.size}px solid ${e.value.border.color}`,
            width: "100%",
            borderCollapse: "collapse"
          })
        }, [
          z("caption", {
            ref_key: "caption",
            ref: C,
            class: "vue-data-ui-carousel-table-caption",
            style: d({
              ...e.value.caption.style,
              fontFamily: "inherit",
              position: "sticky",
              top: 0,
              zIndex: 2,
              paddingTop: e.value.caption.padding.top + "px",
              paddingRight: e.value.caption.padding.right + "px",
              paddingBottom: e.value.caption.padding.bottom + "px",
              paddingLeft: e.value.caption.padding.left + "px",
              boxShadow: R.value ? e.value.thead.tr.style.boxShadow : "none",
              minHeight: "36px"
            })
          }, [
            G(M(e.value.caption.text && !t.$slots.caption ? e.value.caption.text : "") + " ", 1),
            p(t.$slots, "caption", {}, void 0, !0)
          ], 4),
          z("thead", {
            style: d({ ...e.value.thead.style, position: "sticky", top: `${T.value}px`, zIndex: 1 })
          }, [
            z("tr", {
              ref_key: "tableRow",
              ref: $,
              role: "row",
              style: d({
                ...e.value.thead.tr.style,
                border: e.value.thead.tr.border.size ? `${e.value.thead.tr.border.size}px solid ${e.value.thead.tr.border.color}` : "none",
                boxShadow: R.value ? "none" : e.value.thead.tr.style.boxShadow
              }),
              height: `${e.value.thead.tr.height}px`
            }, [
              (u(!0), r(q, null, D(f.dataset.head, (a, i) => (u(), r("th", {
                role: "cell",
                key: `th_${i}`,
                style: d({
                  ...e.value.thead.tr.th.style,
                  border: e.value.thead.tr.th.border.size ? `${e.value.thead.tr.th.border.size}px solid ${e.value.thead.tr.th.border.color}` : "none",
                  paddingTop: e.value.thead.tr.th.padding.top + "px",
                  paddingRight: e.value.thead.tr.th.padding.right + "px",
                  paddingBottom: e.value.thead.tr.th.padding.bottom + "px",
                  paddingLeft: e.value.thead.tr.th.padding.left + "px"
                })
              }, [
                G(M(t.$slots.th ? "" : a) + " ", 1),
                p(t.$slots, "th", X(j({ th: a, colIndex: i })), void 0, !0)
              ], 4))), 128))
            ], 12, Se)
          ], 4),
          f.dataset.body && f.dataset.head ? (u(), r("tbody", {
            key: 0,
            ref_key: "tbody",
            ref: A,
            style: d({
              clipPath: "inset(0,0,0,0)"
            })
          }, [
            (u(!0), r(q, null, D(f.dataset.body, (a, i) => (u(), r("tr", {
              style: d({
                ...e.value.tbody.tr.style,
                border: `${e.value.tbody.tr.border.size}px solid ${e.value.tbody.tr.border.color}`,
                verticalAlign: "middle"
              })
            }, [
              (u(!0), r(q, null, D(a, (c, U) => (u(), r("td", {
                role: "cell",
                "data-cell": f.dataset.head[U] || "",
                style: d({
                  ...e.value.tbody.tr.td.style,
                  border: `${e.value.tbody.tr.td.border.size}px solid ${e.value.tbody.tr.td.border.color}`,
                  backgroundColor: e.value.tbody.tr.td.style.backgroundColor + b(Ie)[i % 2 === 0 && e.value.tbody.tr.td.alternateColor ? e.value.tbody.tr.td.alternateOpacity * 100 : 100],
                  paddingTop: e.value.tbody.tr.td.padding.top + "px",
                  paddingRight: e.value.tbody.tr.td.padding.right + "px",
                  paddingBottom: e.value.tbody.tr.td.padding.bottom + "px",
                  paddingLeft: e.value.tbody.tr.td.padding.left + "px",
                  verticalAlign: "middle"
                }),
                height: `${e.value.tbody.tr.height}px`
              }, [
                G(M(t.$slots.td ? "" : c) + " ", 1),
                p(t.$slots, "td", X(j({ td: c, rowIndex: i, colIndex: U })), void 0, !0)
              ], 12, He))), 256))
            ], 4))), 256))
          ], 4)) : E("", !0)
        ], 4)) : E("", !0)
      ], 46, Ne),
      y.value ? E("", !0) : (u(), de(ze, {
        key: 0,
        config: {
          type: "table"
        }
      })),
      e.value.userOptions.show && y.value ? (u(), de(Re, {
        ref: "details",
        key: `user_option_${ae.value}`,
        backgroundColor: e.value.style.backgroundColor,
        color: e.value.style.color,
        isPrinting: b(Z),
        isImaging: b(_),
        uid: N.value,
        hasTooltip: !1,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: !1,
        hasLabel: !1,
        hasAnimation: e.value.userOptions.buttons.animation,
        isAnimation: !v.value.showAnimation,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: Q.value,
        chartElement: te.value,
        titles: { ...e.value.userOptions.buttonTitles },
        zIndex: 3,
        noOffset: "",
        onGeneratePdf: ie,
        onGenerateCsv: ue,
        onGenerateImage: b(ee),
        onToggleAnimation: se,
        onToggleFullscreen: me
      }, Ae({ _: 2 }, [
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: O(() => [
            p(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: O(() => [
            p(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: O(() => [
            p(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionAnimation ? {
          name: "optionAnimation",
          fn: O(() => [
            p(t.$slots, "optionAnimation", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: O(({ toggleFullscreen: a, isFullscreen: i }) => [
            p(t.$slots, "optionFullscreen", X(j({ toggleFullscreen: a, isFullscreen: i })), void 0, !0)
          ]),
          key: "4"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isPrinting", "isImaging", "uid", "hasPdf", "hasImg", "hasXls", "hasAnimation", "isAnimation", "hasFullscreen", "isFullscreen", "chartElement", "titles", "onGenerateImage"])) : E("", !0)
    ], 512));
  }
}, Xe = /* @__PURE__ */ Ee(Le, [["__scopeId", "data-v-f9b157cb"]]);
export {
  Xe as default
};
